/**********************************************************************
  get option
  $Id: xgetopt.h,v 1.1 2003/07/06 01:37:06 tane Exp $
**********************************************************************/
struct GETOPT_ARG{
  struct STRBUF *sb ;
  int flag ;
} ;

struct GETOPT_LIST{
  unsigned char *name ;
  unsigned char ch ;
  int           flag ;
  int           ret ;
} ;

unsigned char *xgetopt_val ;
unsigned char *xgetopt_str ;
unsigned char *xgetopt_err ;

#define NONARG   0
#define NEEDARG  1

/***********************************************************************/

#define XGETOPT_INIARG(a)      {a.flag=0;a.sb=STR_alloc();}
#define XGETOPT_RESETFLAG(a)   {a.flag=0;}
#define XGETOPT_ADDARG(a,b)    {STR_addlist(a.sb,b);}
#define XGETOPT_ADDTOPARG(a,b) {STR_addtoplist(a.sb,b);}
#define XGETOPT_FREARG(a)      {STR_free(a.sb);}
#define XGETOPT_REFARG(a,n)    STR_refstr(a.sb,n)
#define XGETOPT_REFAGC(a)      (a.sb->size)

#define XGETOPT_INIARGP(a)     {a->flag=0;a->sb=STR_alloc();}
#define XGETOPT_RESETFLAGP(a)  {a->flag=0;}
#define XGETOPT_ADDARGP(a,b)   {STR_addlist(a->sb,b);}
#define XGETOPT_ADDTOPARGP(a,b){STR_addtoplist(a->sb,b);}
#define XGETOPT_FREARGP(a)     {STR_free(a->sb);}
#define XGETOPT_REFARGP(a,n)   STR_refstr(a->sb,n)
#define XGETOPT_REFAGCP(a)     (a->sb->size)

int xgetopt( struct GETOPT_ARG *args, struct GETOPT_LIST *list ) ;

#define XGETOPT_NOT_OPTION     (0)
#define XGETOPT_INVALID_OPTION (-4)
#define XGETOPT_PARSE_COMPLETE (-8)
#define XGETOPT_MALLOC_ERROR   (-16)
#define XGETOPT_ARG_NOT_FOUND  (-17)
